#include <cpctelera.h>
#include "entityman.h"

#include "mapa0.h"
#include "mapa01.h"
#include "mapa02.h"
#include "mapa03.h"
#include "mapa04.h"
#include "hero.h"
#include "bomb.h"
#include "enemy.h"
#include "tiles.h"

#define NUM_ENTITY_ATTRIBS 5
const u8 k_entityTypes[3][NUM_ENTITY_ATTRIBS] = {
   // 0: Player
   {
        0x06                  // Size 12x28 px, 6x28 bytes
      , 0x0C
      , T_Player              // Type of entity: player
      , F_Right               // Entity is facing right
      , 0                    // Status if moving or not
   }
   // 1: Enemy0
,  {
        0x06              // Size 12x28 px, 6x28 bytes
      , 0x0C
      , T_Enemy0           // Type of entity: agent
      , F_Left            // Entity is facing left
      , 0                // Status if moving or not
   }
   // 2: Bomb
,  {
        0x06              // Size 12x28 px, 6x28 bytes
      , 0x0C
      , T_Bomb            // Type of entity: agent
      , F_Left            // Entity is facing left
      , 0                 // Status if moving or not
   }
};

// Entities
#define MAX_ENTITIES 8
TEntity m_entities[MAX_ENTITIES];
u8 m_nEnt;        // Num of active entities
u8 m_nEnemies;    // Number of enemies in the screen

u8 *tileSuelo0
, *tileSuelo1
, *tileSuelo2
;

u8 tileBomba;

u8* mapa;
u8* pvmem;

#define  ORIGEN_MAPA  cpctm_screenPtr(CPCT_VMEM_START, 0, 40)
void dibujarMapa() {
    mapa = g_mapa0;
	cpct_etm_drawTilemap2x4 (g_mapa0_W, g_mapa0_H, ORIGEN_MAPA, mapa);
}

void victory(u8 n){
    switch(n){
    case 0:
        mapa = g_mapa0;
    break;
        case 1:
        mapa = g_mapa01;
    break;
        case 2:
        mapa = g_mapa02;
    break;
    case 3:
        mapa = g_mapa03;
    break;
    case 4:
        mapa = g_mapa04;
    break;
    }

    cpct_etm_drawTilemap2x4 (g_mapa0_W, g_mapa0_H, ORIGEN_MAPA, mapa);
}

cpctm_createTransparentMaskTable(g_tablatrans, 0x0100, M0, 0);


u8* obtenerTilePtr(u8 x, u8 y) {
   return mapa + (y-0)/4*g_mapa0_W + x/2;
}

// EM_getNumEnemies
u8 EM_getNumEnemies() {
   return m_nEnemies;
}

// EM_getHero
TEntity* EM_getHero() {
   return m_entities + 0;
}

// EM_createEntity
TEntity* EM_createEntity(u8 x, u8 y, u8 entityID) {
   TEntity *e = 0;

   // Allocate only if there is space left
   if (m_nEnt < MAX_ENTITIES - 1) {
      // Get next entity slot
      e = m_entities + m_nEnt;
      m_nEnt++;

      // Initial values for the entity
      e->x = e-> px = x; e->y = e->py = y;
      cpct_memcpy(&(e->w), k_entityTypes + entityID, NUM_ENTITY_ATTRIBS);
      if(e->type == 0)
        e->sprite = g_hero_0;
      else if(e->type == 1)
        e->sprite = g_enemy_0;
      else if(e->type == 2)
        e->sprite = g_bomb_00;
   }

   return e;
}

void EM_moveR(TEntity *e) {

	tileSuelo0 = obtenerTilePtr(e->x+6, e->y);
	tileSuelo1 = obtenerTilePtr(e->x+6, e->y+3);
	tileSuelo2 = obtenerTilePtr(e->x+6, e->y+11);

	e->status = 0;
	if (*tileSuelo0 == 12 && *tileSuelo2 == 12) {
		e->x++;
	}
    else if(*tileSuelo1 == 12 && *tileSuelo0 != 12){
        e->x++;
        e->y++;
	}
	else{
        tileSuelo1 = obtenerTilePtr(e->x+6, e->y+8);
        if(*tileSuelo1 == 12 && *tileSuelo2 != 12){
            e->x++;
            e->y--;
        }
	}
}

void EM_moveL(TEntity *e){

	tileSuelo0 = obtenerTilePtr(e->x-1, e->y);
	tileSuelo1 = obtenerTilePtr(e->x-1, e->y+3);
	tileSuelo2 = obtenerTilePtr(e->x-1, e->y+11);

	e->status = 1;
	if (*tileSuelo0 == 12 && *tileSuelo2 == 12) {
		e->x--;
	}
	else if(*tileSuelo1 == 12 && *tileSuelo0 != 12){
        e->x--;
        e->y++;
    }
	else{
        tileSuelo1 = obtenerTilePtr(e->x-1, e->y+8);
        if(*tileSuelo1 == 12 && *tileSuelo2 != 12){
            e->x--;
            e->y--;
        }
	}
}

void EM_moveU(TEntity *e) {

	tileSuelo0 = obtenerTilePtr(e->x, e->y-1);
    tileSuelo1 = obtenerTilePtr(e->x+2, e->y-1);
	tileSuelo2 = obtenerTilePtr(e->x+5, e->y-1);

	e->status = 2;
	if (*tileSuelo0 == 12 && *tileSuelo2 == 12) {
		e->y--;
	}
    else if(*tileSuelo1 == 12 && *tileSuelo0 != 12){
        e->x++;
        e->y--;
	}
	else if(*tileSuelo1 == 12 && *tileSuelo2 != 12){
        e->x--;
        e->y--;
	}

}

void EM_moveD(TEntity *e) {

    tileSuelo0 = obtenerTilePtr(e->x, e->y+12);
    tileSuelo1 = obtenerTilePtr(e->x+2, e->y+12);
	tileSuelo2 = obtenerTilePtr(e->x+5, e->y+12);

    e->status = 3;
    if (*tileSuelo0 == 12 && *tileSuelo2 == 12) {
		e->y++;
	}
    else if(*tileSuelo1 == 12 && *tileSuelo0 != 12){
        e->x++;
        e->y++;
	}
	else if(*tileSuelo1 == 12 && *tileSuelo2 != 12){
        e->x--;
        e->y++;
	}
}

void EM_PonerBomba(TEntity *prota, TEntity *e){

    e->x = prota->x;
    e->y = prota->y;
    tileBomba = 4;

    if(prota->status == 0){ //drcha
        while (tileBomba < prota->x+6)
            tileBomba = tileBomba+6;

        e->x = tileBomba;
        tileSuelo0  = obtenerTilePtr(prota->x+11, prota->y);
        tileSuelo1  = obtenerTilePtr(prota->x+11, prota->y+11);

        if(*tileSuelo0 == 12 && *tileSuelo1 == 12){
            EM_draw(e);
            e->mover = 1;
        }
    }
    else if(prota->status == 1){ //izqda
        while (tileBomba <= prota->x)
            tileBomba = tileBomba+6;

        e->x = tileBomba-12;
        tileSuelo0  = obtenerTilePtr(prota->x-6, prota->y);
        tileSuelo1  = obtenerTilePtr(prota->x-6, prota->y+11);

        if(prota->x > 8)
            if(*tileSuelo0 == 12 && *tileSuelo1 == 12){
                EM_draw(e);
                e->mover = 1;
            }
    }
    else if(prota->status == 2){ //arriba
        tileBomba = 8;
        while (tileBomba <= prota->y)
            tileBomba = tileBomba+12;

        e->y = tileBomba-24;
        tileSuelo0  = obtenerTilePtr(prota->x, prota->y-12);
        tileSuelo1  = obtenerTilePtr(prota->x+5, prota->y-12);

        if(*tileSuelo0 == 12 && *tileSuelo1 == 12){
            EM_draw(e);
            e->mover = 1;
        }
    }
    else if(prota->status == 3){ //abajo
        tileBomba = 8;
        while (tileBomba < prota->y)
            tileBomba = tileBomba+12;

        e->y = tileBomba+12;
        tileSuelo0  = obtenerTilePtr(prota->x, prota->y+23);
        tileSuelo1  = obtenerTilePtr(prota->x+5, prota->y+23);

        if(*tileSuelo0 == 12 && *tileSuelo1 == 12){
            EM_draw(e);
            e->mover = 1;
        }
    }
}

u8 damage_explosion(TEntity *e, TEntity *bomba){

    if ((bomba->x   <= e->x   && bomba->x+5  >= e->x   && bomba->y-11 <= e->y+11 && bomba->y >= e->y+11) ||
        (bomba->x   <= e->x+5 && bomba->x+5  >= e->x+5 && bomba->y-11 <= e->y+11 && bomba->y >= e->y+11) ||

        (bomba->x   <= e->x+5 && bomba->x+5  >= e->x+5 && bomba->y+11 <= e->y    && bomba->y+23 >= e->y) ||
        (bomba->x   <= e->x   && bomba->x+5  >= e->x   && bomba->y+11 <= e->y    && bomba->y+23 >= e->y) ||

        (bomba->x-5 <= e->x+5 && bomba->x    >= e->x+5 && bomba->y    <= e->y+11 && bomba->y+11 >= e->y+11) ||
        (bomba->x-5 <= e->x+5 && bomba->x    >= e->x+5 && bomba->y    <= e->y+11 && bomba->y+11 >= e->y) ||

        (bomba->x+5 <= e->x   && bomba->x+11 >= e->x   && bomba->y    <= e->y+11 && bomba->y+11 >= e->y+11) ||
        (bomba->x+5 <= e->x   && bomba->x+11 >= e->x   && bomba->y    <= e->y+11 && bomba->y+11 >= e->y))
    {
        if (e->type == 0){
            return 1;
        }else{
            EM_clear(e);
            return 0;
        }
    }else{
        if (e->type != 0)
            return 1;
    }
}

void undraw_explosion(TEntity *e){

    cpct_etm_drawTileBox2x4 (e->x / 2, (e->y - 0)/4, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);

    tileSuelo0 = obtenerTilePtr(e->x-2,e->y);
	if (*tileSuelo0 == 12)
        cpct_etm_drawTileBox2x4 ((e->x / 2) - 3, (e->y - 0)/4, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);

    tileSuelo0 = obtenerTilePtr(e->x+8,e->y);
        if (*tileSuelo0 == 12)
    cpct_etm_drawTileBox2x4 ((e->x / 2) + 3, (e->y - 0)/4, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);

    tileSuelo0 = obtenerTilePtr(e->x,e->y-2);
        if (*tileSuelo0 == 12)
    cpct_etm_drawTileBox2x4 (e->x / 2, ((e->y - 0)/4) - 3, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);

    tileSuelo0 = obtenerTilePtr(e->x,e->y+14);
        if (*tileSuelo0 == 12)
    cpct_etm_drawTileBox2x4 (e->x / 2, ((e->y - 0)/4) + 3, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);

}

void draw_explosion(TEntity *e){
	cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x,e->y+40),6,12);

	tileSuelo0 = obtenerTilePtr(e->x+7,e->y+6);
	if (*tileSuelo0 == 12){
        cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x+6,e->y+40),6,12);
        //tileSuelo0 = obtenerTilePtr(e->x+12,e->y+6);
        //if (*tileSuelo0 == 12){
        //    cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x+12,e->y+40),6,12);
        //}
	}

    tileSuelo0 = obtenerTilePtr(e->x-2,e->y+6);
	if (*tileSuelo0 == 12){
        cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x-6,e->y+40),6,12);
        //tileSuelo0 = obtenerTilePtr(e->x-11,e->y);
        //if (*tileSuelo0 == 12){
        //    cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x-12,e->y+40),6,12);
        //}
	}

	tileSuelo0 = obtenerTilePtr(e->x+3,e->y+14);
	if (*tileSuelo0 == 12){
        cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x,e->y+52),6,12);
        //tileSuelo0 = obtenerTilePtr(e->x+3,e->y+24);
        //if (*tileSuelo0 == 12){
        //  cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x,e->y+64),6,12);
        //}
	}

	tileSuelo0 = obtenerTilePtr(e->x+3,e->y-2);
	if (*tileSuelo0 == 12){
        cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x,e->y+28),6,12);
        //tileSuelo0 = obtenerTilePtr(e->x,e->y-23);
        //if (*tileSuelo0 == 12){
        //    cpct_drawSprite (g_bomb_08,cpctm_screenPtr(CPCT_VMEM_START,e->x,e->y+16),6,12);
        //}
	}

}

void EM_draw(TEntity *e) {
	pvmem = cpct_getScreenPtr(CPCT_VMEM_START,e->x, e->y+40);
	cpct_drawSpriteMaskedAlignedTable (e->sprite, pvmem, G_HERO_0_W, G_HERO_0_H, g_tablatrans);
}

void EM_clear(TEntity *e) {
    u8 w, h;
    if(e->type != 2){
        w = 3 + (e->px & 1);
        h = 3 + (e->py & 3 ? 1 : 0);
        cpct_etm_drawTileBox2x4 (e->px / 2, (e->py - 0)/4, w, h, g_mapa0_W, ORIGEN_MAPA, mapa);
    }
	else{
        cpct_etm_drawTileBox2x4 (e->x / 2, (e->y - 0)/4, 3 + (e->x & 1), 3 + (e->y & 3 ? 1 : 0), g_mapa0_W, ORIGEN_MAPA, mapa);
	}

}

void EM_redraw(TEntity *e) {
	EM_clear(e);
	e->px = e->x;
	e->py = e->y;
	EM_draw(e);
}

