#ifndef ENTITYMAN_H
#define ENTITYMAN_H

// Entity Actions
typedef enum {
     A_MoveLeft  = 0x01
   , A_MoveRight = 0x02
   , A_MoveUp    = 0x04
   , A_MoveDown  = 0x08
//   , A_HitAttack = 0x10
} TEntityActions;

// Entity Identifiers
typedef enum {
     E_Player     = 0x00
   , E_Enemy0     = 0x01
   , E_Bomb       = 0x02
} TEntityIDs;

// Entity Types
typedef enum {
     T_Player  = 0x00
   , T_Enemy0  = 0x01
   , T_Bomb    = 0x02
} TEntityType;

// Side towards an entity is facing
typedef enum {
      F_Right    = 0x00
   ,  F_Left     = 0x01
   ,  F_Up       = 0x02
   ,  F_Down     = 0x03
} TFacing;

// Entity definition
typedef struct Entity {
   u8               x, y;  // Esquina superior izda
   u8             px, py;  // Pixeles previos para el movimiento
   u8               w, h;  // Width-height
   TEntityType      type;  // Type of entity
   u8             status;  // Status byte for the entity
   u8              mover;  // Status if moving or not
   u8*            sprite;  // Sprite currently being drawn
} TEntity;

// Functions
void     EM_initialize();
TEntity* EM_createEntity(u8 x, u8 y, u8 entType);
TEntity* EM_getHero();
u8       EM_getNumEnemies();
void     EM_update();

void     EM_clear(TEntity *e);
void     EM_moveL(TEntity *e);
void     EM_moveR(TEntity *e);
void     EM_moveU(TEntity *e);
void     EM_moveD(TEntity *e);
void     EM_PonerBomba(TEntity *prota, TEntity *e);

void victory(u8 n);
u8 damage_explosion(TEntity *e, TEntity *bomba);
void draw_explosion(TEntity *e);
void undraw_explosion(TEntity *e);

void     EM_draw(TEntity *e);
void     EM_redraw(TEntity *e);

#endif // ENTITYMAN_H
